<?php
namespace Ecommerce\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\ParameterBag;

class Movopitempedcol extends \Teknisa\Libs\Controller\CRUD
{
    protected $dataSourceName = 'movopitempedcol';
    protected $connection;
    protected $environment;
    
    public function __construct($crudService, ParameterBag $parameterBag, $connection, $environment) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->con = $connection;
        $this->environment = $environment;
    }
    
    public function salvar(DTO\Request $request, DTO\Response $response) {
		try {
			$dataset = $request->getDataSet()->getRows();
			$sqlInsert = "INSERT INTO MOVOPITEMPEDCOL (CDFILIAL, CDFORNECED, CDMARCA, CDPRODUTO, CDREGIAO, DSALTERITPEDCOL, DSJUSTITPEDCOL, NRPEDCOLETA, NRORG) VALUES (:P_CDFILIAL, :P_CDFORNECED, :P_CDMARCA, :P_CDPRODUTO, :P_CDREGIAO, :P_DSALTERITPEDCOL, :P_DSJUSTITPEDCOL, :P_NRPEDCOLETA, :NRORG)";
			$sqlUpdate = "UPDATE MOVOPITEMPEDCOL SET DSALTERITPEDCOL = :P_DSALTERITPEDCOL, DSJUSTITPEDCOL = :P_DSJUSTITPEDCOL WHERE CDFILIAL = :P_CDFILIAL AND CDFORNECED = :P_CDFORNECED AND CDMARCA = :P_CDMARCA AND CDPRODUTO = :P_CDPRODUTO AND CDREGIAO = :P_CDREGIAO AND NRPEDCOLETA = :P_NRPEDCOLETA AND NRORG = :NRORG";
			
			foreach($dataset as $row) {
                if($this->verificaExiste($row, $response) == 1) {
                    $stmt = $this->con->prepare($sqlUpdate);
                } else {
                    $stmt = $this->con->prepare($sqlInsert);
                }
                $stmt->execute(
                    array(
                        "P_CDFILIAL"        => $row['CDFILIAL'],
                        "P_CDFORNECED"      => $row['CDFORNECED'],
                        "P_CDMARCA"         => $row['CDMARCA'],
                        "P_CDPRODUTO"       => $row['CDPRODUTO'],
                        "P_CDREGIAO"        => $row['CDREGIAO'],
                        "P_DSALTERITPEDCOL" => $row['DSALTERITPEDCOL'],
                        "P_DSJUSTITPEDCOL"  => $row['DSJUSTITPEDCOL'],
                        "P_NRPEDCOLETA"     => $row['NRPEDCOLETA'],
                        "NRORG"             => $this->environment->getNrOrgTrab()
                    )
                );
			}
		} catch (\Exception $e) {
			$response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
		}
	}
	
	public function verificaExiste($row, $response) {
		try {
			$sql = "SELECT 1 FROM MOVOPITEMPEDCOL WHERE CDFILIAL = :P_CDFILIAL AND CDFORNECED = :P_CDFORNECED AND CDMARCA = :P_CDMARCA AND CDPRODUTO = :P_CDPRODUTO AND CDREGIAO = :P_CDREGIAO AND NRPEDCOLETA = :P_NRPEDCOLETA AND NRORG = :NRORG";
            $stmt = $this->con->prepare($sql);
            $stmt->execute(
                array(
                    "P_CDFILIAL"        => $row['CDFILIAL'],
                    "P_CDFORNECED"      => $row['CDFORNECED'],
                    "P_CDMARCA"         => $row['CDMARCA'],
                    "P_CDPRODUTO"       => $row['CDPRODUTO'],
                    "P_CDREGIAO"        => $row['CDREGIAO'],
                    "P_NRPEDCOLETA"     => $row['NRPEDCOLETA'],
                    "NRORG"             => $this->environment->getNrOrgTrab()
                )
            );
			$result = $stmt->fetchAll();
			return sizeof($result);
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), $e->getCode()));
		}
	}
	
	public function retornaDados(DTO\Request $request, $response) {
		try {
		    $row = $request->getRow();
			$sql = "SELECT * FROM MOVOPITEMPEDCOL WHERE CDFILIAL = :P_CDFILIAL AND CDFORNECED = :P_CDFORNECED AND CDMARCA = :P_CDMARCA AND CDPRODUTO = :P_CDPRODUTO AND CDREGIAO = :P_CDREGIAO AND NRPEDCOLETA = :P_NRPEDCOLETA AND NRORG = :NRORG";
            $stmt = $this->con->prepare($sql);
            $stmt->execute(
                array(
                    "P_CDFILIAL"        => $row[0]['CDFILIAL'],
                    "P_CDFORNECED"      => $row[0]['CDFORNECED'],
                    "P_CDMARCA"         => $row[0]['CDMARCA'],
                    "P_CDPRODUTO"       => $row[0]['CDPRODUTO'],
                    "P_CDREGIAO"        => $row[0]['CDREGIAO'],
                    "P_NRPEDCOLETA"     => $row[0]['NRPEDCOLETA'],
                    "NRORG"             => $this->environment->getNrOrgTrab()
                )
            );
			$result = $stmt->fetchAll();
			$response->addDataset(new DataSet('movopitempedcol', $result));
		} catch (\Exception $e) {
			$response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
		}
	}
    
}